<script lang="ts">
import Vue from 'vue';
import SurveyBubbleTable from './survey-bubble-table.vue';
import SurveyTextResults from './survey-text-results.vue';
import SurveyResultsRadio from './survey-results-radio.vue';

export default Vue.extend({
  name: 'SurveyCarousel',
  components: {
    SurveyBubbleTable,
    SurveyTextResults,
    SurveyResultsRadio,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: () => ({}),
    },
    controlsOnTop: {
      type: Boolean,
      required: false,
      default: false,
    },
    components: {
      type: Object,
      required: false,
      default: () => {},
    },
  },
  data() {
    return {
      currentSlide: 0,
      prefersReducedMotion: false,
    };
  },
  computed: {
    slideCount() {
      if (this.components) {
        return this.components.data.length;
      } else if (this.data.blocks) {
        return this.data.blocks.length;
      } else return 0;
    },
    buttonGaName() {
      const currentBlock = this.data.blocks?.[this.currentSlide];
      const currentComponent = this.components?.data?.[this.currentSlide];

      if (currentBlock) {
        return (currentBlock.header || currentBlock.dataGaName || '')
          .toLowerCase()
          .replace(/[\r\n]+$/, '');
      }

      if (currentComponent && currentComponent.header) {
        return currentComponent.header.toLowerCase().replace(/[\r\n]+$/, '');
      }

      return '';
    },
  },
  methods: {
    prevSlide() {
      if (this.currentSlide > 0) {
        this.currentSlide--;
      } else {
        this.currentSlide = this.slideCount - 1;
      }
    },
    nextSlide() {
      if (this.currentSlide < this.slideCount - 1) {
        this.currentSlide++;
      } else {
        this.currentSlide = 0;
      }
    },
  },
});
</script>
<template>
  <div class="survey-carousel" :class="{ inverse: controlsOnTop }">
    <transition-group
      v-if="data.blocks && data.blocks.length"
      name="slide-fade"
      tag="div"
      class="slides"
      aria-live="polite"
    >
      <div
        v-for="(item, index) in data.blocks"
        v-show="index === currentSlide"
        :key="item.header || item.text"
        class="slide"
      >
        <SlpTypography
          v-if="item.header"
          variant="heading5-bold"
          tag="p"
          class="slp-mb-8"
        >
          {{ item.header }}
        </SlpTypography>
        <SlpTypography variant="body2" tag="div">
          <div class="slide__text" v-html="$md.render(item.text)" />
        </SlpTypography>
      </div>
    </transition-group>
    <div v-else class="slides">
      <div
        v-for="(component, index) in components.data"
        v-show="index === currentSlide"
        :key="`${component.type || component.name}-${index}`"
        class="slide"
      >
        <component
          :is="components.type || component.name"
          :key="`${Math.random()}`"
          :data="component"
        />
      </div>
    </div>
    <div class="controls">
      <button
        class="button"
        aria-label="Previous slide"
        :data-ga-name="`previous - ${buttonGaName}`"
        :data-ga-location="data.gaLocation || 'body'"
        @click="prevSlide"
      >
        {{ data.buttons.previous }}
      </button>
      <div class="progress">
        <div>{{ currentSlide + 1 }}/{{ slideCount }}</div>
      </div>
      <button
        class="button"
        aria-label="Next slide"
        :data-ga-name="`next - ${buttonGaName}`"
        :data-ga-location="data.gaLocation || 'body'"
        @click="nextSlide"
      >
        {{ data.buttons.next }}
      </button>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.survey-carousel {
  background: #f6f3fe;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  height: 100%;

  &.inverse {
    flex-direction: column-reverse;
  }

  .slides {
    position: relative;
    flex-grow: 1;
    min-height: 200px;
    height: 100%;
    display: flex;
    align-items: center;
    overflow: hidden;
  }

  .controls {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-top: 16px;
    flex-shrink: 0;

    .button {
      flex-grow: 1;
      width: 100%;
      outline: none;
      border: none;
      font-family: 'GitLab Mono';
      font-size: 14px;
      display: inline-flex;
      align-items: center;
      background: #2f2a6b;
      border-radius: 999px;
      color: #fdf1dd;
      padding: 4px 16px;
      text-align: center;
      justify-content: center;
      cursor: pointer;
      transition: background 0.2s ease-in-out;

      &:focus-visible {
        outline-style: solid;
        outline-color: #5943b6;
      }

      &:hover {
        background: #5943b6;
      }
    }

    .progress {
      flex-grow: 1;
      padding: 0 16px;
      text-align: center;
      font-family: 'GitLab Mono';
    }
  }

  .slide {
    width: 100%;
    flex-shrink: 0;
    display: flex;
    flex-direction: column;
  }

  .slide:deep {
    .survey-results-radio {
      margin-top: 24px;
    }
  }

  .slide__text {
    &:deep {
      .stat,
      .number {
        font-family: 'GitLab Mono';
        font-size: 80px;
        line-height: 80px;
      }
      .orange {
        color: #fc6d26;
      }

      .teal {
        color: #10b1b1;
      }

      .red {
        color: #e24329;
      }

      .purple {
        color: #7759c2;
      }
    }
  }
}

.slide-fade-enter-active,
.slide-fade-leave-active {
  transition: opacity 0.3s;
}

.slide-fade-enter,
.slide-fade-leave-to {
  opacity: 0;
}
</style>
